﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AwInitilizer.Interface
{
    public enum ConnectStatus
    {
        Cleared, Connecting, Connected, DisConnected, ConnectionFail
    }

    public interface ISerialPort : INotifyPropertyChanged
    {
        ConnectStatus ConnectStatus { get; }

        void Open();
        Task OpenAsync();
        void Close();

        void WriteData(byte[] msg);
        event EventHandler<byte[]> OnDataReceived;
    }
}
