﻿using AwInitilizer.Procedure;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AwInitilizer
{
    public class MainViewModel : Model.UpdateData,INotifyPropertyChanged
    {
        private string _UserID;
        public string UserID
        {
            get => _UserID;
            set
            {
                if(_UserID!=value)
                {
                    _UserID = value;
                    RaisePropertyChanged(nameof(UserID));
                }
            }
        }

        private string _WorkOrder;
        public string WorkOrder
        {
            get => _WorkOrder;
            set
            {
                if (_WorkOrder != value)
                {
                    _WorkOrder = value;
                    RaisePropertyChanged(nameof(WorkOrder));
                }
            }
        }

        private bool _IsUdatIng = false;
        public bool IsUpdating
        {
            get => _IsUdatIng;
            set
            {
                if(_IsUdatIng!=value)
                {
                    _IsUdatIng = value;
                    RaisePropertyChanged("IsUdatIng");
                    RaisePropertyChanged("IsInputLock");
                }
            }
        }

        private bool _IsInputCheckpassed = false;
        public bool IsInputCheckpassed
        {
            get => _IsInputCheckpassed;
            set
            {
                if(_IsInputCheckpassed != value)
                {
                    _IsInputCheckpassed = value;
                    RaisePropertyChanged(nameof(IsInputCheckpassed));
                }
            }
        }

        public bool IsInputLock => !IsUpdating;

        private string _SettingFileName;
        public string SettingFileName
        {
            get => _SettingFileName;
            set
            {
                if (_SettingFileName != value)
                {
                    _SettingFileName = value;
                    RaisePropertyChanged("SettingFileName");
                }
            }
        }

        private string _SettingModelName;
        public string SettingModelName
        {
            get => _SettingModelName;
            set
            {
                if (_SettingModelName != value)
                {
                    _SettingModelName = value;
                    RaisePropertyChanged("SettingModelName");
                }
            }
        }

        private ObservableCollection<ProcedureBase> _updateProcedure;
        public ObservableCollection<ProcedureBase> UpdateProcedure
        {
            get => _updateProcedure;
            set
            {
                if (_updateProcedure != value)
                {
                    if(_updateProcedure!=null)
                    {
                        _updateProcedure.CollectionChanged -= _updateProcedure_CollectionChanged;
                    }

                    _updateProcedure = value;
                    RaisePropertyChanged("UpdateProcedure");
                }
            }
        }

        public TimeSpan UpdateElpased { get; set; }

        public MainViewModel()
        {
            _updateProcedure = new ObservableCollection<ProcedureBase>();
            _updateProcedure.CollectionChanged += _updateProcedure_CollectionChanged;
        }

        private void _updateProcedure_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            RaisePropertyChanged("UpdateProcedure");
        }
    }
}
