﻿using InitializerModel;
using PhihongEv.Lib;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AwInitilizer.Model
{
    public class UpdateData : ObservableObject
    {
        private SystemID _SystemID;
        public SystemID SystemID {
            get => _SystemID;
            set => SetProperty(ref _SystemID, value);
        }

        private string _ModelName;
        public string ModelName {
            get => _ModelName;
            set => SetProperty(ref _ModelName, value);
        }

        private string _SerialNumber;
        public string SerialNumber
        {
            get => _SerialNumber;
            set => SetProperty(ref _SerialNumber, value);
        }

        private string _FourGenModuleVersion;
        public string FourGenModuleVersion
        {
            get => _FourGenModuleVersion;
            set => SetProperty(ref _FourGenModuleVersion, value);
        }

        private string _SubFourGenModuleVersion;
        public string SubFourGenModuleVersion
        {
            get => _SubFourGenModuleVersion;
            set => SetProperty(ref _SubFourGenModuleVersion, value);
        }

        private bool _IsSimInsert;
        public bool IsSimInsert
        {
            get => _IsSimInsert;
            set => SetProperty(ref _IsSimInsert, value);
        }

        private string _SimICCID;
        public string SimICCID {
            get => _SimICCID;
            set
            {
                if (SetProperty(ref _SimICCID, value))
                {
                    RaisePropertyChanged(nameof(UiSimICCID));
                }
            }
        }

        private string _SimIMSI;
        public string SimIMSI
        {
            get => _SimIMSI;
            set
            {
                if (SetProperty(ref _SimIMSI, value))
                {
                    RaisePropertyChanged(nameof(UiSimIMSI));
                }
            }
        }

        private bool _IsSubSimInsert;
        public bool IsSubSimInsert
        {
            get => _IsSubSimInsert;
            set => SetProperty(ref _IsSubSimInsert, value);
        }

        private string _SubSimICCID;
        public string SubSimICCID
        {
            get => _SubSimICCID;
            set
            {
                if (SetProperty(ref _SubSimICCID, value))
                {
                    RaisePropertyChanged(nameof(UiSimICCID));
                }
            }
        }

        private string _SubSimIMSI;
        public string SubSimIMSI
        {
            get => _SubSimIMSI;
            set
            {
                if (SetProperty(ref _SubSimIMSI, value))
                {
                    RaisePropertyChanged(nameof(UiSimIMSI));
                }
            }
        }

        public string UiSimICCID => string.IsNullOrEmpty(SubSimICCID) ? SimICCID : $"{SimICCID}/{SubSimICCID}";
        public string UiSimIMSI => string.IsNullOrEmpty(SubSimIMSI) ? SimIMSI : $"{SimIMSI}/{SubSimIMSI}";

        private ButtonTestModeType _ButtonTestMode;
        public ButtonTestModeType ButtonTestMode
        {
            get => _ButtonTestMode;
            set => SetProperty(ref _ButtonTestMode, value);
        }

        //private bool _SkipEmergencyButton;
        //public bool SkipEmergencyButton
        //{
        //    get => _SkipEmergencyButton;
        //    set
        //    {
        //        if (_SkipEmergencyButton != value)
        //        {
        //            _SkipEmergencyButton = value;
        //            RaisePropertyChanged("SkipEmergencyButton");
        //        }
        //    }
        //}

        //private bool _SkipButtonTest;
        //public bool SkipButtonTest
        //{
        //    get => _SkipButtonTest;
        //    set
        //    {
        //        if (_SkipButtonTest != value)
        //        {
        //            _SkipButtonTest = value;
        //            RaisePropertyChanged("SkipButtonTest");
        //        }
        //    }
        //}

        private string _IpAddress;
        public string IpAddress
        {
            get => _IpAddress;
            set => SetProperty(ref _IpAddress, value);
        }

        private bool _IsDisableAuthRequired;
        public bool IsDisableAuthRequired
        {
            get => _IsDisableAuthRequired;
            set => SetProperty(ref _IsDisableAuthRequired, value);
        }

        private bool _IsIdleCheckPass;
        public bool IsIdleCheckPass
        {
            get => _IsIdleCheckPass;
            set => SetProperty(ref _IsIdleCheckPass, value);
        }

        private List<FirmwareUpdateModel> _FirmwareUpdateModels;
        public List<FirmwareUpdateModel> FirmwareUpdateModels
        {
            get => _FirmwareUpdateModels;
            set => SetProperty(ref _FirmwareUpdateModels, value);
        }

        private List<FirmwareUpdateModel> _PreFlashFirmwareUpdateModels;
        public List<FirmwareUpdateModel> PreFlashFirmwareUpdateModels
        {
            get => _PreFlashFirmwareUpdateModels;
            set => SetProperty(ref _PreFlashFirmwareUpdateModels, value);
        }
    }
}
