﻿using AwInitilizer.Assist;
using CsuWebApiLib;
using InitializerModel;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace AwInitilizer.Procedure.FactoryAssist
{
    public class DsiableChargeAuthProcedure : ProcedureBase
    {
        public enum ErrorType
        {
            None,
        }

        public enum LogEvent
        {
        }

        public ErrorType Error { get; set; } = ErrorType.None;

        private ProcedureLog.LogWriter<DsiableChargeAuthProcedure, LogEvent> LogWriter;

        public DsiableChargeAuthProcedure() : base()
        {
            Name = "Disable Charging Auth";
            Content = "Disable Charging auth for factory test";

            LogWriter = new ProcedureLog.LogWriter<DsiableChargeAuthProcedure, LogEvent>(this);
        }

        internal override async Task<bool> Run()
        {
            //if (!AppSettingConfig.Instance.IsDisableAuthRequired)
            if (!UpdateData.IsDisableAuthRequired)
            {
                return false;
            }

            var result = await EvApi.SetAuthorisationMode(isAuthRequired: false);

            LogWriter.Log(result.Response);

            return result.Result;
        }
    }
}
